/*
 * Copyright 2000 by Jean-Claude Christophe <jch@oleane.net>
 *                                          <jch@bsdfr.org>
 *
 * Home page:  http://www.bsdfr.org/projects/tac_bsd/
 *
 * misc.c  Some functions used in all others .c files.
 */

#include <stdio.h>
#include <pwd.h>    /* getpass(3) */
#include <unistd.h>
#include <syslog.h>
#include <signal.h>

#include "tac_bsd.h"
#include "conf.h"

#define LOCK_FILE "/tmp/tac_bsd.lck"

void logintimeout(int);

int alarmtype;

/* check if file or directory exist */
int
file_exist(file)
    char *file;
{
    FILE *fp;
    
    fp = fopen(file, "r");
    if (!fp)
	return(-1);
    fclose(fp);
    return(0);
}


/* get from login.c of standard BSD */
char *
getloginname(prompt)
    char *prompt;
{
    int ch;
    char *p;
    static char nbuf[32];

    for (;;) {
	printf("%s", prompt);
	for (p = nbuf; (ch = getchar()) != '\n';) {
	    if (ch == EOF) {}
	    if (p < nbuf + (32 - 1))
		*p++ = ch;
	}
	if (p > nbuf) {
	    *p = '\0';
	    break;
	}
    }
    return(nbuf);
}

void
authenticate()
{
    /* Username */
/*    if (maxlogintime) {
	(void)signal(SIGALRM, logintimeout);
	(void)alarm(maxlogintime);
	alarmtype = ALARM_USER;
	}*/

    username = getloginname("Username: ");

    /* Password */
/*    if (maxlogintime) {
	(void)signal(SIGALRM, logintimeout);
	(void)alarm(maxlogintime);
	alarmtype = ALARM_PASS;
	}*/

    password = getpass("Password: ");

/*    (void)signal(SIGALRM, SIG_IGN);
      (void)alarm(0);*/
}

void
logintimeout(signo)
    int signo;
{
    extern int try;
    extern void close_quit();

    switch (alarmtype) {
    case ALARM_USER:
	printf("\nUsername:  timeout expired!\n");
	break;
    case ALARM_PASS:
	printf("\nPassword:  timeout expired!\n");
	break;
    default:
	break;
    }
/*    (void)alarm(0);*/
/*      (void)signal(SIGALRM, SIG_IGN);*/
    try++;
    if (try == maxtry) {
	if (slog)
	    syslog(_syslog, "connect from %s: timeout after %d seconds", port, maxlogintime);
	close_quit();
    } else
	authenticate();
}

int
lock()
{
    FILE *fp;
    
    fp = fopen(LOCK_FILE, "w");
    if (!fp)
	return(-1);
    return(0);
}

int
unlock()
{
    unlink(LOCK_FILE);
    return(0);
}

int
checklock()
{
    FILE *fp;
    
    fp = fopen(LOCK_FILE, "r");
    if (fp)
	return(1); // file exists
    return(0); // file doesn't exist
}
